<template>
  <div ref="imageContainer" class="fact-segment">
    <div class="fact-segment__info">
      <WikiLogo
        v-if="first"
        :title="title"
        :logoElement="logoElement"
        :randomColor="randomColor"
      />

      <p style="width: 70%">
        <span :class="['fact-segment__text', randomColor]"> {{ text }}</span>
      </p>

      <WikiAttribution
        class="fact-segment__attribution"
        :imageAttribution="imageAttribution"
      />
    </div>
  </div>
</template>

<script lang="ts" setup>
import { onMounted, ref } from 'vue';
import WikiLogo from './WikiLogo.vue';
import WikiAttribution from './WikiAttribution.vue';

const props = defineProps<{
  title: string;
  text: string;
  imageUrl: string;
  imageElement: HTMLImageElement | undefined;
  imageAlignment: string;
  randomColor: string;
  imageAttribution: string;
  narrationTime: number;
  playbackSpeed: number;
  kenBurns: string;
  first: boolean;
  logoElement: HTMLImageElement | undefined;
}>();

const animationSpeed = `calc(20s / ${props.playbackSpeed})`;

const imageContainer = ref<HTMLDivElement | null>(null);

onMounted(() => {
  const image = props.imageElement;
  if (!image) return;

  image.className = 'fact-segment__image';
  if (imageContainer.value === null) return;
  const dataAttribute = imageContainer.value
    ?.getAttributeNames()
    .find((attr) => attr.startsWith('data-v-'));
  if (dataAttribute) {
    image.setAttribute(dataAttribute, '');
  }
  imageContainer.value.appendChild(image);
});
</script>

<style scoped lang="less">
.fact-segment {
  position: absolute;
  top: 0;
  bottom: 0;
  left: 0;
  right: 0;
  display: flex;
  flex-direction: column;

  &__image {
    position: absolute;
    top: 0;
    left: 0;
    bottom: 0;
    right: 0;
    width: 100%;
    height: 100%;
    object-fit: cover;
    object-position: v-bind(imageAlignment);
    animation: v-bind(kenBurns) v-bind(animationSpeed) ease infinite;
    z-index: 0;
  }

  &__info {
    margin-top: 333px;
    display: flex;
    height: 100%;
    flex-direction: column;
    padding-left: 50px;
    padding-right: 50px;
    z-index: 1;
  }

  &__attribution {
    transform: rotate(90deg);
    transform-origin: left top;
    margin-top: 112px;
    margin-left: 27px;
  }

  &__text {
    font-size: 46px;
    line-height: 86px;
    padding: 12px 24px;
    box-decoration-break: clone;
    -webkit-box-decoration-break: clone;
  }
}
</style>
